/**************** Defines for windows package ***************************/

#define        SHSV           0     /* single horiz single vert line */
#define        DHSV           1     /* double horiz single vert line */
#define        DHDV           2
#define        SHDV           3
#define        BHBV           4     /* block horiz block vert line */
#define        INVERSE        5		/* inverse video border */
#define			NOZOOM			10    /* don't zoom box */
#define			LEFT			   0
#define			CENTER			1
#define			RIGHT			   2
#define        BLOCK          -1    /* block cursor */
#define        LINE           0     /* line cursor */

#define        WINDOW         struct _windowdata

extern struct _windowdata {
	char *writebuffer;  	/* window buffer for writing */
	char *savebuffer;		/* screen buffer for saving old screen */
   char *editbuffer;
	int toprow;
	int leftcol;
	int bottomrow;
	int rightcol;
	int height;
	int width;
	int rowcurrent;		/* location of cursor in window */
	int colcurrent;		
	int oldrowcursor;	/* location of cursor in last window */
	int oldcolcursor;
	int stoprow;		/* point behind which we will not backspace */
	int stopcol;
   int index;        /* various uses */
};

extern WINDOW *wopen();
extern char *wptr(), *wedit();
